from itertools import permutations
from tsp import *

"""
----------
ACTIVITY 1
----------
Read the code in main() for activity 1, and add the necessary code to test()
"""


"""
----------
ACTIVITY 2
----------
Write your implementation of total_dist() below this comment
"""


"""
----------
ACTIVITY 3
----------
Write your implementation of exhaustive_search() below this comment
"""


"""
----------
ACTIVITY 4
----------
Run the main function with the input 4 for this activity

THEN, confirm that you have the files that you need in img/ before continuing
"""


"""
----------
ACTIVITY 5
----------
How many times do I need to check the distance between two points when running greedy_search?

"""


"""
----------
ACTIVITY 6
----------
Write your implementation of greedy_search() below this comment
"""


"""
----------
ACTIVITY 7
----------
Run the main function with the input 7 for this activity

THEN, describe here how greedy search performs in comparison to the random tour 
and exhaustive search. Is it closer to one or the other?


"""


"""
----------
ACTIVITY 8
----------
Run the main function with the input 8 for this activity

THEN, write your answer here to please compare the runtime of exhaustive_search() 
and greedy_search() when there are 10 locations to be visited:

"""


"""
----------
ACTIVITY 9
----------
Your answer here (please try to show your work):

"""

"""
----------
ACTIVITY 10
----------
Run the main function with the input 10 for this activity.

THEN, look at the generated plots in img/ to see how the greedy search performs on a larger 
list of locations
"""


def test():
    """
    Put any code that you use to test your functions here!
    """



def main():
    activity = input("Which activity are you completing? OPTIONS: 4/7/8/10/test  ").lower()

    if activity == "test":
        test()

    elif activity == "4":
        locs = random_locations(10)

        seq = random_tour(locs)
        plot_tour(seq, locs, "Random Tour")

        best_seq, best_dist = exhaustive_search(locs)
        plot_tour(best_seq, locs, "Exhaustive Search")

    elif activity == "7":
        # we do this a second time so that you can compare the algorithms using the same random 
        # locations
        locs = random_locations(10)

        seq = random_tour(locs)
        plot_tour(seq, locs, "Random Tour")

        seq, dist = exhaustive_search(locs)
        plot_tour(seq, locs, "Exhaustive Search")

        seq, dist = greedy_search(locs)
        plot_tour(seq, locs, "Greedy Search")

    elif activity == "8":
        max_n = 10

        exhaustive_times = []
        for n in range(2, max_n + 1):
            # NOTE: here, I use a function as an argument. 
            # This is not something that you need to know how to do!
            exhaustive_times.append(time_search(exhaustive_search, n))
        plot_times(exhaustive_times, "Exhaustive Search Times")

        greedy_times = []
        for n in range(2, max_n + 1):
            greedy_times.append(time_search(greedy_search, n))
        plot_times(greedy_times, "Greedy Search Times")


    elif activity == "10":
        max_n = 201

        greedy_times = []
        for n in range(2, max_n):
            greedy_times.append(time_search(greedy_search, n))
        plot_times(greedy_times, "Greedy Search Times Large")

        locs = random_locations(max_n)
        seq, dist = greedy_search(locs)
        plot_tour(seq, locs, "Greedy Search Large")

    else:
        print("Invalid activity choice. Please try again.")


if __name__ == "__main__":
    main()
